# Locate libzip
# This module defines
# libzip_LIBRARY
# libzip_FOUND, if false, do not try to link to libzip 
# libzip_INCLUDE_DIR, where to find the headers
#

FIND_PATH(libzip_INCLUDE_DIR zip.h
    ${CMAKE_INCLUDE_PATH}
    $ENV{libzip_DIR}/include
    $ENV{libzip_DIR}
    $ENV{OSGDIR}/include
    $ENV{OSGDIR}
    $ENV{OSG_ROOT}/include
    ~/Library/Frameworks
    /Library/Frameworks
    /usr/local/include
    /usr/include
    /sw/include # Fink
    /opt/local/include # DarwinPorts
    /opt/csw/include # Blastwave
    /opt/include
    [HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session\ Manager\\Environment;OSG_ROOT]/include
    /usr/freeware/include
)

FIND_LIBRARY(libzip_LIBRARY 
    NAMES libzip zip
    PATHS
    ${CMAKE_LIBRARY_PATH}
    $ENV{libzip_DIR}/lib
    $ENV{libzip_DIR}
    $ENV{OSGDIR}/lib
    $ENV{OSGDIR}
    $ENV{OSG_ROOT}/lib
    ~/Library/Frameworks
    /Library/Frameworks
    /usr/local/lib
    /usr/lib
    /sw/lib
    /opt/local/lib
    /opt/csw/lib
    /opt/lib
    [HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session\ Manager\\Environment;OSG_ROOT]/lib
    /usr/freeware/lib64
)

SET(libzip_FOUND "NO")
IF(libzip_LIBRARY AND libzip_INCLUDE_DIR)
    SET(libzip_FOUND "YES")
ENDIF(libzip_LIBRARY AND libzip_INCLUDE_DIR)

