#include <stdio.h>
#include <stdlib.h>
#include <sndfile.h>

int writefloatfile(char *fname, float *data, int frames, int ch){

  SF_INFO sfinfo;
  SNDFILE *fp;

  sfinfo.samplerate = 16000;
  sfinfo.channels = ch;
  sfinfo.format = SF_FORMAT_RAW | SF_FORMAT_FLOAT | SF_ENDIAN_LITTLE;
  sfinfo.sections = -1;
  sfinfo.seekable = -1;
  
  if(sf_format_check(&sfinfo) != 1 ){
	  fprintf(stderr, "error in format\n");
	  exit(1);
  }

  if( (fp = sf_open(fname, SFM_WRITE, &sfinfo)) == NULL ){
    perror("sf_open");
    return -1;
  }

  sf_writef_float(fp, data, frames);
  sf_close(fp);
  
  return 1;
}

// read float
int readfloatfile(char *fname, int ch, int samplerate,
				  double **data, int *frames){

	int i,j;
	int count;
	SNDFILE *fp;
	SF_INFO sfinfo;
	float *tmp;
  
	sfinfo.samplerate = samplerate;
	sfinfo.channels = ch;
	sfinfo.format = SF_FORMAT_RAW | SF_FORMAT_FLOAT | SF_ENDIAN_LITTLE;
	sfinfo.sections = -1;
	sfinfo.seekable = -1;
  
	if(sf_format_check(&sfinfo) != 1 ){
		fprintf(stderr, "error in format\n");
		exit(1);
	}

	if( (fp = sf_open(fname, SFM_READ, &sfinfo)) == NULL ){
		perror("sf_open");
		return -1;
	}

	count = sf_seek(fp, 0, SEEK_END);
	sf_seek(fp, 0, SEEK_SET);

	// printf("size = %d\n", count);
  
	if( (tmp = (float *)malloc(sizeof(float) * count * ch) ) 
		== NULL ){
		perror("malloc");
		exit(0);
	}

	if( (*data = (double *)malloc(sizeof(double) * count * ch) ) 
		== NULL ){
		perror("malloc");
		exit(0);
	}

	sf_readf_float(fp, tmp, count);

	for(i=0; i<ch; i++){
		for(j=0; j<count; j++){
			(*data)[j*ch+i] = (double)tmp[j*ch+i];
		}
	}

	*frames = count;
	free(tmp);
	
	return 1;
}

